from arguments import get_args
from solver_vae import VAESolver
from solver_our import OurSolver

def main():
    args = get_args()

    if args.alg == 'vae':
        solver = VAESolver(args)
    elif args.alg == 'our':
        solver = OurSolver(args)
    else:
        raise NotImplementedError

    print('training!')
    solver.solve()
    print('done')

if __name__ == '__main__':
    main()
